// CompiladorDoc.cpp : implementation of the CCompiladorDoc class
//

#include "stdafx.h"
#include "Compilador.h"

#include "CompiladorDoc.h"
#include "CntrItem.h"
#include <afxtempl.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCompiladorDoc

IMPLEMENT_DYNCREATE(CCompiladorDoc, CRichEditDoc)

BEGIN_MESSAGE_MAP(CCompiladorDoc, CRichEditDoc)
	//{{AFX_MSG_MAP(CCompiladorDoc)
	ON_COMMAND(ID_LEXBASED, OnLexbased)
	ON_UPDATE_COMMAND_UI(ID_LEXBASED, OnUpdateLexbased)
	//}}AFX_MSG_MAP
	// Enable default OLE container implementation
	ON_UPDATE_COMMAND_UI(ID_OLE_EDIT_LINKS, CRichEditDoc::OnUpdateEditLinksMenu)
	ON_COMMAND(ID_OLE_EDIT_LINKS, CRichEditDoc::OnEditLinks)
	ON_UPDATE_COMMAND_UI(ID_OLE_VERB_FIRST, CRichEditDoc::OnUpdateObjectVerbMenu)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCompiladorDoc construction/destruction

CCompiladorDoc::CCompiladorDoc()
{
	m_bRTF = FALSE;
	m_bLexBased = true;
}

CCompiladorDoc::~CCompiladorDoc()
{
}

BOOL CCompiladorDoc::OnNewDocument()
{
	if (!CRichEditDoc::OnNewDocument())
		return FALSE;

	return TRUE;
}

CRichEditCntrItem* CCompiladorDoc::CreateClientItem(REOBJECT* preo) const
{
	// cast away constness of this
	return new CCompiladorCntrItem(preo, (CCompiladorDoc*) this);
}



/////////////////////////////////////////////////////////////////////////////
// CCompiladorDoc serialization

void CCompiladorDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
	}
	else
	{
	}
	CRichEditDoc::Serialize(ar);
}

/////////////////////////////////////////////////////////////////////////////
// CCompiladorDoc diagnostics

#ifdef _DEBUG
void CCompiladorDoc::AssertValid() const
{
	CRichEditDoc::AssertValid();
}

void CCompiladorDoc::Dump(CDumpContext& dc) const
{
	CRichEditDoc::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCompiladorDoc commands

COMPCODE CCompiladorDoc::Compile(CString& strOutPath, CTimeSpan& timeSpan) 
{
	CWaitCursor waitCursor;
	CString strInPath = GetPathName();
	
	if (strInPath.IsEmpty()) {
		if (AfxMessageBox(IDS_MSG1, 
			MB_YESNO | MB_ICONQUESTION) == IDYES) 
		{ 
			OnFileSave();
			strInPath = GetPathName();

			if (strInPath.IsEmpty()) 
				return COMP_ERROR;
		}
		else return COMP_ERROR;
	}
	else if (IsModified()) {
		OnFileSave();
	}

	int i;
	CString strCmdLine;

	if ((i = strInPath.Find('.')) == -1) {
		m_strExePath = strInPath;
		strOutPath.Format("%s.out", strInPath);
	}
	else {
		m_strExePath = strInPath.Left(i);
		strOutPath.Format("%s.out", m_strExePath);
	}

	char szDOSPath[_MAX_PATH];

	if (::GetShortPathName(m_strExePath, szDOSPath, _MAX_PATH) == 0)
		return COMP_ERROR;

	strCmdLine.Format(" %s %s %s.asm", strInPath, strOutPath, m_strExePath);
	
	CTime startTime = CTime::GetCurrentTime();

	DWORD res;
	
	res = EjecutarProceso("Parser.exe", strCmdLine.GetBuffer(0));

	if (res != 0) {
		switch (res) {
			case 500: return PARSER_CONERROR;
			case 1000: return PARSER_NOEJEC;
			default: return COMP_ERROR;
		}
	}

	strCmdLine.Format("Tasm.exe %s.asm > log.txt", szDOSPath);

	res = EjecutarProceso("Tasm.exe", strCmdLine.GetBuffer(0), false);

	if (res != 0) 
		return (res == 1000) ? TASM_NOEJEC:TASM_CONERROR;

	strCmdLine.Format("Tlink.exe %s.obj >> log.txt", szDOSPath);

	res = EjecutarProceso("Tlink.exe", strCmdLine.GetBuffer(0), false);

	if (res != 0) 
		return (res == 1000) ? TLINK_NOEJEC:TLINK_CONERROR;
	
	CTime endTime = CTime::GetCurrentTime();

	timeSpan = endTime - startTime;

	return COMP_OK;
}

void CCompiladorDoc::OnLexbased() 
{
	m_bLexBased = !m_bLexBased;
}

void CCompiladorDoc::OnUpdateLexbased(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((m_bLexBased) ? 1:0);
}

DWORD CCompiladorDoc::EjecutarProceso(char* szProceso, char* szCmdLine, 
									  bool bShowWindow /*=true*/)
{
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	DWORD dwExitCode = 1;

	::ZeroMemory(&si, sizeof(si));
	si.cb = sizeof(si);
	
	if(!bShowWindow) {
		si.dwFlags = STARTF_USESHOWWINDOW;
		si.wShowWindow = SW_HIDE;
	}
	
	BOOL fSuccess = ::CreateProcess(szProceso, szCmdLine, 
		NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);

	if (fSuccess) {
		CloseHandle(pi.hThread);

		WaitForSingleObject(pi.hProcess, INFINITE);

		GetExitCodeProcess(pi.hProcess, &dwExitCode);

		CloseHandle(pi.hProcess);
	}
	else {
		CString msg;
		msg.Format("Error al ejecutar %s %s", szProceso, szCmdLine);
		AfxMessageBox(msg, MB_ICONSTOP);
		return 1000;
	}

	return dwExitCode;
}
