// CompiladorDoc.cpp : implementation of the CCompiladorDoc class
//

#include "stdafx.h"
#include "Compilador.h"

#include "CompiladorDoc.h"
#include "CntrItem.h"
#include <afxtempl.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCompiladorDoc

IMPLEMENT_DYNCREATE(CCompiladorDoc, CRichEditDoc)

BEGIN_MESSAGE_MAP(CCompiladorDoc, CRichEditDoc)
	//{{AFX_MSG_MAP(CCompiladorDoc)
	ON_COMMAND(ID_LEXBASED, OnLexbased)
	ON_UPDATE_COMMAND_UI(ID_LEXBASED, OnUpdateLexbased)
	//}}AFX_MSG_MAP
	// Enable default OLE container implementation
	ON_UPDATE_COMMAND_UI(ID_OLE_EDIT_LINKS, CRichEditDoc::OnUpdateEditLinksMenu)
	ON_COMMAND(ID_OLE_EDIT_LINKS, CRichEditDoc::OnEditLinks)
	ON_UPDATE_COMMAND_UI(ID_OLE_VERB_FIRST, CRichEditDoc::OnUpdateObjectVerbMenu)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCompiladorDoc construction/destruction

CCompiladorDoc::CCompiladorDoc()
{
	m_bRTF = FALSE;
	m_bLexBased = true;
}

CCompiladorDoc::~CCompiladorDoc()
{
}

BOOL CCompiladorDoc::OnNewDocument()
{
	if (!CRichEditDoc::OnNewDocument())
		return FALSE;

	return TRUE;
}

CRichEditCntrItem* CCompiladorDoc::CreateClientItem(REOBJECT* preo) const
{
	// cast away constness of this
	return new CCompiladorCntrItem(preo, (CCompiladorDoc*) this);
}



/////////////////////////////////////////////////////////////////////////////
// CCompiladorDoc serialization

void CCompiladorDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
	}
	else
	{
	}
	CRichEditDoc::Serialize(ar);
}

/////////////////////////////////////////////////////////////////////////////
// CCompiladorDoc diagnostics

#ifdef _DEBUG
void CCompiladorDoc::AssertValid() const
{
	CRichEditDoc::AssertValid();
}

void CCompiladorDoc::Dump(CDumpContext& dc) const
{
	CRichEditDoc::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCompiladorDoc commands

bool CCompiladorDoc::Compile(CString& strOutPath, CTimeSpan& timeSpan) 
{
	CString strInPath = GetPathName();
	
	if (strInPath.IsEmpty()) {
		if (AfxMessageBox(IDS_MSG1, 
			MB_YESNO | MB_ICONQUESTION) == IDYES) 
		{ 
			OnFileSave();
			strInPath = GetPathName();

			if (strInPath.IsEmpty()) 
				return false;
		}
		else return false;
	}
	else if (IsModified()) {
		OnFileSave();
	}

	int i;
	CString strCmdLine;

	if ((i = strInPath.Find('.')) == -1)
		strOutPath.Format("%s.out", strInPath);
	else
		strOutPath.Format("%s.out", strInPath.Left(i));

	strCmdLine.Format(" %s %s", strInPath, strOutPath);
	
	/* Start of pipe connection */
	HANDLE hSaveStdout, hChildStdoutWr;
	SECURITY_ATTRIBUTES saAttr;

	// Set the bInheritHandle flag so pipe handles are inherited.
	saAttr.nLength = sizeof(SECURITY_ATTRIBUTES);
	saAttr.bInheritHandle = TRUE;
	saAttr.lpSecurityDescriptor = NULL;

	// Save the handle to the current STDOUT.  
	hSaveStdout = GetStdHandle(STD_OUTPUT_HANDLE); 

	// Create a pipe for the child process's STDOUT.  
	if (!CreatePipe(&m_hPipe, &hChildStdoutWr, &saAttr, 0)) {
		AfxMessageBox("Stdout pipe creation failed");
		return false;
	}

	// Set a write handle to the pipe to be STDOUT.  
	if (!SetStdHandle(STD_OUTPUT_HANDLE, hChildStdoutWr)) {
		AfxMessageBox("Redirecting STDOUT failed");  
		return false;
	}

	// Now we are ready to create a child process.

	/* End of pipe connection */
	
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	DWORD dwExitCode;

	CTime startTime = CTime::GetCurrentTime();

	::ZeroMemory(&si, sizeof(si));
	si.cb = sizeof(si);

	char* szParser = (m_bLexBased) ? "Parser.exe":"OurParser.exe";
	
	BOOL fSuccess = ::CreateProcess(szParser, strCmdLine.GetBuffer(0), 
		NULL, NULL, TRUE /*inherit handles*/, 0, NULL, NULL, &si, &pi);

	// Restore stdout handle
	CloseHandle(hChildStdoutWr);
	if (!SetStdHandle(STD_OUTPUT_HANDLE, hSaveStdout)) {
      AfxMessageBox("Re-redirecting Stdout failed"); 
	  return false;
	}

	if (fSuccess) {
		CloseHandle(pi.hThread);

		WaitForSingleObject(pi.hProcess, INFINITE);

		GetExitCodeProcess(pi.hProcess, &dwExitCode);

		CloseHandle(pi.hProcess);
	}
	else {
		AfxMessageBox(IDS_MSG2, MB_ICONSTOP);
		return false;
	}

	if (dwExitCode != 0) return false;

	CTime endTime = CTime::GetCurrentTime();

	timeSpan = endTime - startTime;

	return true;
}

void CCompiladorDoc::OnLexbased() 
{
	m_bLexBased = !m_bLexBased;
}

void CCompiladorDoc::OnUpdateLexbased(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((m_bLexBased) ? 1:0);
}
