// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Compilador.h"

#include "MainFrm.h"
#include "OutputView.h"
#include "CompiladorDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_COMPILE, OnCompile)
	ON_COMMAND(ID_EXECUTE, OnExecute)
	ON_UPDATE_COMMAND_UI(ID_EXECUTE, OnUpdateExecute)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.style = WS_OVERLAPPED | WS_CAPTION | FWS_ADDTOTITLE
		| WS_THICKFRAME | WS_SYSMENU | WS_MINIMIZEBOX | WS_MAXIMIZEBOX | WS_MAXIMIZE;

	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
	CRect rect;
	GetClientRect(rect);

	if (!m_wndSplitter.CreateStatic(this, 2, 1)) {
		TRACE("Error al crear spliter");
		return FALSE;
	}

	// enganchar primer spliter
	if (!m_wndSplitter.CreateView(0, 0, pContext->m_pNewViewClass,
		CSize( 0, rect.bottom ), pContext)) 
	{
		TRACE("Error al crear el primer spliter pane");
		return FALSE;
	}

	// enganchar segundo spliter
	if (!m_wndSplitter.CreateView(1, 0, RUNTIME_CLASS(COutputView),
		CSize( 100, 100 ), pContext)) 
	{
		TRACE("Error al crear el segundo spliter pane");
		return FALSE;
	}
	
	return TRUE; //CFrameWnd::OnCreateClient(lpcs, pContext);
}


/* Enganchando manualmente la view de salida al doc */
/*//CDocument* pDoc = GetActiveDocument();
	if (!pContext || !pContext->m_pCurrentDoc) 
		AfxMessageBox("No hay doc activo");
	else
		pContext->m_pCurrentDoc->AddView((CView*)m_wndSplitter.GetPane(1, 0));
*/

void CMainFrame::OnCompile() 
{
	CCompiladorDoc* pDoc = (CCompiladorDoc*) GetActiveDocument();
	ASSERT_VALID(pDoc);
	COutputView* pView = (COutputView*) m_wndSplitter.GetPane(1, 0);

	CString strPath;
	CTimeSpan timeSpan;

	pView->OnCompile(strPath, timeSpan, pDoc->Compile(strPath, timeSpan));
}

void CMainFrame::OnExecute() 
{
	CCompiladorDoc* pDoc = (CCompiladorDoc*) GetActiveDocument();
	CString strExe;

	strExe.Format("%s.exe", pDoc->m_strExePath);

	pDoc->EjecutarProceso(strExe.GetBuffer(0), NULL);
}

void CMainFrame::OnUpdateExecute(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}
