/* Matriz.h */


/* Rutinas semnticas */
int OnID(char c);                       // Al leer un identificador
int OnEndID(char c);                    // Al terminar de leer un identificador (chequea por las palabras reservadas)
int OnCons(char c);                     // Al leer una constante
int OnEndCons(char c);                  // Al terminar de leer una constante
int OnOpCmp(char c);                    // Al leer un operador de comparacin
int OnOpArit(char c);                   // Al leer una operador aritmtico
int OnStr(char c);                      // Al leer un string
int OnEndStr(char c);                   // Al terminar de leer un string
int OnPunt(char c);                     // Al leer un smbolo de puntuacin como: {, }, (, ), [, ],...
int OnError(char c);                    // Al encontrar un error


/*                                      Letra [0]   Digito [1]  / [2]      * [3]      <, >, =, ! [4]  +, -, % [5] Separador [6]  " [7]      Esp, \ [8]  Puntuacin [9]  */
int newState[7][10] = {
                      /* Inicial [0] */ {1,         2,          3,         END,       END,            END,        0,             6,         END,        END},
                /* Identificador [1] */ {1,         1,          END,       END,       END,            END,        END,           END,       END,        END},
                    /* Constante [2] */ {END,       2,          END,       END,       END,            END,        END,           END,       END,        END},
    /* Posible com. u operador / [3] */ {END,       END,        END,       4,         END,            END,        END,           END,       END,        END},
                   /* Comentario [4] */ {4,         4,          4,         5,         4,              4,          4,             4,         4,          4},
    /* Posible fin de comentario [5] */ {4,         4,          0,         5,         4,              4,          4,             4,         4,          4},
                       /* String [6] */ {6,         6,          6,         6,         6,              6,          6,             END,       6,          6}};

/*                                      Letra [0]   Digito [1]  / [2]      * [3]      <, >, =, ! [4]  +, -, % [5] Separador [6]  " [7]      Esp, \ [8]  Puntuacin [9]  */
int (*pfSemRut[7][10])(char) = {
                      /* Inicial [0] */ {OnID,      OnCons,     NULL,      OnOpArit,  OnOpCmp,        OnOpArit,   NULL,          OnStr,     OnError,    OnPunt},
                /* Identificador [1] */ {OnID,      OnID,       OnEndID,   OnEndID,   OnEndID,        OnEndID,    OnEndID,       OnEndID,   OnEndID,    OnEndID},
                    /* Constante [2] */ {OnEndCons, OnCons,     OnEndCons, OnEndCons, OnEndCons,      OnEndCons,  OnEndCons,     OnEndCons, OnEndCons,  OnEndCons},
    /* Posible com. u operador / [3] */ {OnOpArit,  OnOpArit,   OnOpArit,  NULL,      OnOpArit,       OnOpArit,   OnOpArit,      OnOpArit,  OnOpArit,   OnOpArit},
                   /* Comentario [4] */ {NULL,      NULL,       NULL,      NULL,      NULL,           NULL,       NULL,          NULL,      NULL,       NULL},
    /* Posible fin de comentario [5] */ {NULL,      NULL,       NULL,      NULL,      NULL,           NULL,       NULL,          NULL,      NULL,       NULL},
                       /* String [6] */ {OnStr,     OnStr,      OnStr,     OnStr,     OnStr,          OnStr,      OnStr,         OnEndStr,  OnStr,      OnStr}};
